

// DO01 - OCTAL DIGITAL OUTPUT BUFFER


// Includes
#include "device.hpp"


// Preprocessor Directives
#pragma once


// Class DO01
class DO01 : public Device
{
public:

   // Channels
   static const uint8_t CHANNELS = 8;

   // States
   static const bool STATE_LOW = false;
   static const bool STATE_HIGH = true;

   // Constructor
   DO01(const IP::Address& address);
   DO01(const Device& device);

   // Measure Current [A]
   float measure(uint8_t channel) const;
   std::map<uint8_t, float> measure(void) const;
   std::map<uint8_t, float> measure(const std::set<uint8_t>& channel) const;

   // Write
   void write(bool state) const;
   void write(uint8_t channel, bool state) const;
   void write(const std::set<uint8_t>& channel, bool state) const;
   void write(const std::map<uint8_t, bool>& state) const;

private:

   // DCP Message Types
   static const uint16_t _MESSAGE_WRITE = 0x0100;
   static const uint16_t _MESSAGE_MEASURE = 0x0101;
   static const uint16_t _MESSAGE_CURRENT = 0x0102;
};
